<template>
  <div v-if="showLengths && (minLength || maxLength)" class="row">
    <div class="col d-flex justify-content-end">
      <small class="text-muted">
        <span v-if="minLength"> Min: {{ minLength }} </span>
        <span v-if="maxLength">
          ({{ value ? `${value}`.length : 0 }}/{{ maxLength }})
        </span>
      </small>
    </div>
  </div>
  <div v-if="props.loading" class="row py-2">
    <div class="col placeholder-wave">
      <span class="placeholder col-12 placeholder-lg" />
    </div>
  </div>
  <div v-else class="form-floating">
    <input
      v-bind="$attrs"
      :id="id"
      v-model.trim="value"
      :placeholder="label"
      :maxLength="maxLength"
      :minLength="minLength"
      class="form-control"
      :required="props.required"
    />
    <label :for="id"> {{ label }}<span v-if="required">*</span> </label>
  </div>
  <div v-if="props.footnote" class="row">
    <div class="col d-flex justify-content-start">
      <p class="text-muted small pt-1">
        {{ footnote }}
      </p>
    </div>
  </div>
</template>

<script>
export default {
  inheritAttrs: false,
};
</script>

<script setup>
import { computed } from "vue";

const emit = defineEmits(["update:modelValue"]);

const props = defineProps({
  id: {
    type: String,
    required: false,
  },
  footnote: {
    type: String,
    required: false,
  },
  label: {
    type: String,
    required: false,
  },
  loading: {
    type: Boolean,
    required: false,
    default: false,
  },
  minLength: {
    type: [String, Number],
    required: false,
  },
  maxLength: {
    type: [String, Number],
    required: false,
  },
  required: {
    type: Boolean,
    required: false,
    default: false,
  },
  modelValue: {
    type: [String, Number],
    required: false,
  },
  showLengths: {
    type: Boolean,
    required: false,
    default: true,
  },
});

const value = computed({
  get() {
    return props.modelValue;
  },
  set(event) {
    emit("update:modelValue", event);
  },
});
</script>

<style></style>
